"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DefaultGraphQLFilesystem = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _chokidar = require("chokidar");

var _graphqlConfigUtilities = require("graphql-config-utilities");

var _graphqlFilesystem = require("./graphql-filesystem.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var DefaultGraphQLFilesystem = /*#__PURE__*/function (_AbstractGraphQLFiles) {
  _inherits(DefaultGraphQLFilesystem, _AbstractGraphQLFiles);

  var _super = _createSuper(DefaultGraphQLFilesystem);

  function DefaultGraphQLFilesystem() {
    var _this;

    _classCallCheck(this, DefaultGraphQLFilesystem);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.watchers = [];
    return _this;
  }

  _createClass(DefaultGraphQLFilesystem, [{
    key: "watch",
    value: function () {
      var _watch = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee(config) {
        var _this$watchers;

        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                (_this$watchers = this.watchers).push.apply(_this$watchers, _toConsumableArray(this.setupDocumentWatchers(config).concat(this.setupSchemaWatcher(config))));

                _context.next = 3;
                return Promise.all(this.watchers.map(function (watcher) {
                  return new Promise(function (resolve) {
                    return watcher.on('ready', function () {
                      return resolve();
                    });
                  });
                }));

              case 3:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function watch(_x) {
        return _watch.apply(this, arguments);
      }

      return watch;
    }()
  }, {
    key: "dispose",
    value: function dispose() {
      this.watchers.forEach(function (watcher) {
        watcher.close();
      });
      this.watchers.length = 0;
    }
  }, {
    key: "getGraphQLProjectIncludedFilePaths",
    value: function getGraphQLProjectIncludedFilePaths(projectConfig) {
      return (0, _graphqlConfigUtilities.getGraphQLProjectIncludedFilePaths)(projectConfig);
    }
  }, {
    key: "setupDocumentWatchers",
    value: function setupDocumentWatchers(config) {
      var _this2 = this;

      return (0, _graphqlConfigUtilities.getGraphQLProjects)(config).filter(function (_ref) {
        var includes = _ref.includes;
        return includes.length > 0;
      }).map(function (projectConfig) {
        return (0, _chokidar.watch)(projectConfig.includes.map(function (include) {
          return (0, _graphqlConfigUtilities.resolvePathRelativeToConfig)(projectConfig, include);
        }), {
          ignored: projectConfig.excludes.map(function (exclude) {
            return (0, _graphqlConfigUtilities.resolvePathRelativeToConfig)(projectConfig, exclude);
          }),
          ignoreInitial: true
        }).on('add', function (filePath) {
          return _this2.emit('change:document', filePath, projectConfig);
        }).on('change', function (filePath) {
          return _this2.emit('change:document', filePath, projectConfig);
        }).on('unlink', function (filePath) {
          return _this2.emit('delete:document', filePath, projectConfig);
        });
      });
    }
  }, {
    key: "setupSchemaWatcher",
    value: function setupSchemaWatcher(config) {
      var _this3 = this;

      return (0, _chokidar.watch)((0, _graphqlConfigUtilities.getGraphQLSchemaPaths)(config), {
        ignoreInitial: true
      }).on('change', function (schemaPath) {
        return _this3.emit('change:schema', schemaPath);
      });
    }
  }]);

  return DefaultGraphQLFilesystem;
}(_graphqlFilesystem.AbstractGraphQLFilesystem);

exports.DefaultGraphQLFilesystem = DefaultGraphQLFilesystem;