"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.OperationContext = exports.FileContext = void 0;

var _path = require("path");

var t = _interopRequireWildcard(require("@babel/types"));

var _upperCaseFirst = require("upper-case-first");

var _graphqlToolUtilities = require("graphql-tool-utilities");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var FileContext = /*#__PURE__*/function () {
  _createClass(FileContext, [{
    key: "schemaImports",
    get: function get() {
      var path = this.path,
          importedTypes = this.importedTypes,
          schemaTypesPath = this.options.schemaTypesPath;
      return importedTypes.size > 0 ? t.importDeclaration(_toConsumableArray(importedTypes).map(function (type) {
        return t.importSpecifier(t.identifier(type), t.identifier(type));
      }), t.stringLiteral(importPath(path, schemaTypesPath))) : null;
    }
  }]);

  function FileContext(path, options) {
    _classCallCheck(this, FileContext);

    this.path = path;
    this.options = options;
    this.importedTypes = new Set();
  }

  _createClass(FileContext, [{
    key: "import",
    value: function _import(type) {
      this.importedTypes.add(type);
    }
  }]);

  return FileContext;
}();

exports.FileContext = FileContext;

var OperationContext = /*#__PURE__*/function () {
  _createClass(OperationContext, [{
    key: "typeName",
    get: function get() {
      var typeName;

      if ((0, _graphqlToolUtilities.isOperation)(this.operation)) {
        var _this$operation = this.operation,
            operationName = _this$operation.operationName,
            operationType = _this$operation.operationType;
        typeName = "".concat((0, _upperCaseFirst.upperCaseFirst)(operationName)).concat((0, _upperCaseFirst.upperCaseFirst)(operationType), "Data");
      } else {
        var fragmentName = this.operation.fragmentName;
        typeName = "".concat((0, _upperCaseFirst.upperCaseFirst)(fragmentName), "FragmentData");
      }

      return this.options.partial ? typeName.replace(/Data$/, 'PartialData') : typeName;
    }
  }, {
    key: "namespace",
    get: function get() {
      var exported = this.exported,
          typeName = this.typeName;
      return exported.length > 0 ? t.tsModuleDeclaration(t.identifier(typeName), t.tsModuleBlock(exported.map(function (type) {
        return t.exportNamedDeclaration(type, []);
      }))) : null;
    }
  }, {
    key: "exported",
    get: function get() {
      return this.exportedTypes;
    }
  }]);

  function OperationContext(operation, ast, options, file) {
    _classCallCheck(this, OperationContext);

    this.operation = operation;
    this.ast = ast;
    this.options = options;
    this.file = file;
    this.exportedTypes = [];
  }

  _createClass(OperationContext, [{
    key: "export",
    value: function _export(type) {
      this.exportedTypes.push(type);
      return t.tsTypeReference(t.tsQualifiedName(t.identifier(this.typeName), t.identifier(type.id.name)));
    }
  }]);

  return OperationContext;
}();

exports.OperationContext = OperationContext;

function importPath(from, to) {
  var relativePath = (0, _path.relative)((0, _path.dirname)(from), to);
  var normalizedPath = relativePath.startsWith('..') ? relativePath : "./".concat(relativePath);
  return normalizedPath.replace(/\.ts$/, '');
}